#include "OgreOcclusionCullingTerrainSceneManager.h"
#include "OgreMath.h"
#include "OgreIteratorWrappers.h"
#include "OgreRenderSystem.h"
#include "OgreCamera.h"
#include "OgreHardwareOcclusionQuery.h"
//#include "OgreWireBoundingBox.h"
#include "OgreSolidHalfBoundingBox.h"

//#include <windows.h>

namespace Ogre {
	//-----------------------------------------------------------------------
	OcclusionCullingTerrainSceneManager::OcclusionCullingTerrainSceneManager()
	{
		mOcclusionCullingSceneTraverser = new OcclusionCullingSceneTraverser(this, mDestRenderSystem);
		mDisplayNodes = true;
		//mShowBoundingBoxes = true;
		mShowBoxes = true;
	}
	//-----------------------------------------------------------------------
	OcclusionCullingTerrainSceneManager::~OcclusionCullingTerrainSceneManager()
	{
		delete mOcclusionCullingSceneTraverser;
	}
	//-----------------------------------------------------------------------
	/*void OcclusionCullingTerrainSceneManager::_renderVisibleObjects(void)
	{
		mOcclusionCullingSceneTraverser->renderScene(mCameraInProgress, mSceneRoot);
	}
	//-----------------------------------------------------------------------
	void OcclusionCullingTerrainSceneManager::_findVisibleObjects(Camera* cam, bool onlyShadowCasters)
	{
		// must be empty because objects are found and rendered in an interleaved fashion
		// in _renderVisibibleObjects 
	}
	//-----------------------------------------------------------------------
	void OcclusionCullingTerrainSceneManager::_updateSceneGraph(Camera* cam)
	{
        mOcclusionCullingSceneTraverser->preprocess();

		TerrainSceneManager::_updateSceneGraph(cam);
	}*/
	//-----------------------------------------------------------------------
	bool OcclusionCullingTerrainSceneManager::setOption( const String & key, const void * val )
	{
		return mOcclusionCullingSceneTraverser->setOption( key, val) || TerrainSceneManager::setOption( key, val );
	}
	//-----------------------------------------------------------------------
	bool OcclusionCullingTerrainSceneManager::getOption( const String & key, void *val )
	{
		return mOcclusionCullingSceneTraverser->getOption( key, val) || TerrainSceneManager::getOption( key, val ) ;
	}
	//-----------------------------------------------------------------------
	bool OcclusionCullingTerrainSceneManager::getOptionValues( const String & key, StringVector  &refValueList )
	{
		return TerrainSceneManager::getOptionValues( key, refValueList );
	}
	//-----------------------------------------------------------------------
	bool OcclusionCullingTerrainSceneManager::getOptionKeys( StringVector & refKeys )
	{
		return mOcclusionCullingSceneTraverser->getOptionKeys ( refKeys ) || TerrainSceneManager::getOptionKeys( refKeys );
	}
}	
